import { TaskMagicService } from "./task.magics.service";
import { ComponentListMagicService } from "./component-list.magic.service";
/**
 * Implements various table-related functionalities
 */
export declare class TableMagicService {
    protected componentList: ComponentListMagicService;
    protected task: TaskMagicService;
    selectedItem: any;
    /**
     *
     * @param componentList Component-mapping service
     * @param task Magic task service
     */
    constructor(componentList: ComponentListMagicService, task: TaskMagicService);
    shouldOpenFieldTextEditor: boolean;
    /**
     * Refreshes the DataSource
     */
    refreshDataSource(): void;
    /**
     * Returns the table page size
     */
    getPageSize(): number;
    /**
     * Returns max no of rows in the table.
     */
    getMaxRowsInTable(): number;
    /**
     * Selects the specified row
     * @param rowId The row to select
     */
    selectRow(rowId: string): void;
    getSelectedRow(): any;
    /**
     * Returns the selected row
     */
    selectedRow(): any;
    /**
     * Selects the specified page
     * @param  pageId The page to select
     */
    selectPage(pageId: number): void;
    /**
     * Returns whether a dialog should be opened for the HTML element
     * @param  element The HTML element for which a dialog may be needed
     * @returns
     */
    OpenDialogForControl(element: HTMLElement): boolean;
    /**
     * Returns the dialog used to edit values
     */
    getDialog(): any;
    /**
     * Handles the table "scrolled" event
     */
    onScrollDown(): void;
    /**
     * To be overwitten in specific implelemtations
     */
    sortData(e: any): void;
    /**
     * To be overwitten in specific implelemtations
     */
    mgOnPaginateChange(e: any): void;
    /**
     * Change the number of lines in a table
     * @param  size New number of lines in table
     */
    updateTableSize(size: number): void;
    /**
     * @ignore
     */
    setTableTopIndex(value: number): void;
    /**
     * @ignore
     */
    getTableTopIndex(): number;
}
